import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.Timer;

public class M08Surf implements ActionListener {
	//--------------------------------------萔
	//̑傫
	final int x_max=30;
	final int y_max=30;
	//n}̂P}X̑傫
	final int map_size=5;
	//---------------------------------------ϐ
	//ĂяõAvbg
	M08Panel panel;
	//݈ʒuƊpx
	double posx,posy;
	int angle;
	//ʒuƊpx
	int posx_s,posy_s;
	int angle_s;
	//ړtO
	boolean ahead,back,right,left;
	//OiށE]̃Xs[h
	double speed;
	int rotation;
	//
	int star_num;
	int star_x[];
	int star_y[];
	//nʂɗĂ
	int ball_num;
	Point balls[];
	boolean ball_get[];
	double ball_r_ratio[];
	int ball_depth_max;
	int ball_width_max;
	int ball_r_max;
	double ball_get_length;
	int ball_paint_x[];
	int ball_paint_y[];
	//^񒆂̌
	Point hole;
	double hole_r_ratio;
	int hole_r_max;
	int hole_paint_x;
	int hole_paint_y;
	//ʌʗp
	int flow1,flow2;
	int flow2_d;
	//Aj[Vp̃^C}[
	Timer timer;
	//---------------------------------------
	//RXgN^
	public M08Surf(M08Panel panel){
		//
		this.panel=panel;
		//
		posx_s=(int)(x_max/2);
		posy_s=(int)(y_max/2)-1;
		angle_s=-90;
		//
		ahead=false;
		back=false;
		right=false;
		left=false;
		//
		speed=0.2;
		rotation=6;
		//
		star_num=40;
		star_x=new int[star_num];
		star_y=new int[star_num];
		//
		ball_num=4;
		balls=new Point[ball_num];
		ball_get=new boolean[ball_num];
		//
		ball_r_ratio=new double[ball_num];
		ball_depth_max=5;
		ball_width_max=5;
		ball_r_max=30;
		ball_get_length=0.5;
		ball_paint_x=new int[ball_num];
		ball_paint_y=new int[ball_num];
		//
		hole=new Point((int)(x_max/2),(int)(y_max/2));
		hole_r_max=2*ball_r_max;
		//ʌ
		flow1=0;
		flow2=0;
		flow2_d=1;
		//========================
		formatPos();
		//
		for(int i=0;i<ball_num;i++){
			setBall(i);
		}
		//==========================^C}[
		timer=new Timer(200,this);
		timer.start();
	}
	//-------------------------------------
	//ʒuƐ
	public void formatPos(){
		posx=posx_s;
		posy=posy_s;
		angle=angle_s;
		//
		for(int i=0;i<star_num;i++){
			star_x[i]=(int)(Math.random()*800);
			star_y[i]=(int)(Math.random()*400);
		}
	}
	//-------------------------------------
	//ʂzu
	public void setBall(int num){
		int x,y;
		boolean flag;
		do{
			flag=false;
			do{
				x=(int)(Math.random()*x_max);
				y=(int)(Math.random()*y_max);
			}while( (x==hole.x && y==hole.y) || (Math.abs(x-posx_s)<=ball_get_length && Math.abs(y-posy_s)<=ball_get_length) );
			//
			for(int i=0;i<num;i++){
				if(x==balls[i].x && y==balls[i].y){
					flag=true;
					break;
				}
			}
		}while(flag);
		balls[num]=new Point(x,y);
		ball_get[num]=false;
	}
	//--------------------------------------
	//`
	public void paintSurf(Graphics offScreenG){
		//n
		int ox=400;
		int oy=700;
		int rx=650;
		int ry=400;
		for(int i=0;i<75;i++){
			if(ahead){
				flow1+=1;
				if(flow1>=4){	flow1=0;	}
			}else if(back){
				flow1-=1;
				if(flow1<0){	flow1=5;	}
			}else if(right || left){
				flow1=(int)(Math.random()*4);
			}
			offScreenG.setColor(new Color(0,30+2*i,0));
			offScreenG.fillOval(ox-rx,oy-ry-flow1,2*rx,2*ry);
			oy+=4;
			rx-=4;
		}
		//
		if(ahead || back){
			flow2+=flow2_d*1;
			if(flow2>=6 || flow2<=0){
				flow2_d=-1*flow2_d;
			}
		}
		offScreenG.setColor(Color.black);
		offScreenG.fillRect(0,0,800,400+flow2);
		//
		offScreenG.setColor(Color.white);
		for(int i=0;i<star_num;i++){
			int r=1+(int)((600-star_y[i])/200);
			offScreenG.fillOval(star_x[i],star_y[i],r,r);
		}
		//n}
		offScreenG.setColor(new Color(0,55,0));
		offScreenG.fillRect(600,40,150,150);
		//
		for(int i=0;i<ball_num;i++){
			offScreenG.setColor(Color.orange);
			if(ball_get[i]){
				offScreenG.fillOval(100+50*i,10,30,30);
				continue;
			}else{
				offScreenG.drawOval(100+50*i,10,30,30);
			}
			//
			offScreenG.setColor(Color.white);
			int x=600+balls[i].x*map_size;
			int y=40+balls[i].y*map_size;
			offScreenG.fillOval(x,y,map_size,map_size);
			//
			if(ball_r_ratio[i]>0){
				int r=(int)(ball_r_max*ball_r_ratio[i]);
				offScreenG.setColor(Color.black);
				offScreenG.fillOval(ball_paint_x[i]-r,ball_paint_y[i]+(int)(r/2),2*r,1*r);
				offScreenG.setColor( new Color((int)(100+155*ball_r_ratio[i]),(int)(50+150*ball_r_ratio[i]),0) );
				offScreenG.fillOval(ball_paint_x[i]-r,ball_paint_y[i]-r,2*r,2*r);
			}
		}
		//
		offScreenG.setColor(Color.black);
		int x=600+hole.x*map_size;
		int y=40+hole.y*map_size;
		offScreenG.fillOval(x-map_size,y-map_size,2*map_size,2*map_size);
		//
		if(hole_r_ratio>0){
			int r=(int)(hole_r_max*hole_r_ratio);
			offScreenG.fillOval(hole_paint_x-r,hole_paint_y+(int)(r/2),2*r,1*r);
		}
		//
		double dx=600+posx*map_size;
		double dy=40+posy*map_size;
		int px[]={(int)(dx+2*map_size*Math.cos(Math.PI*angle/180)),(int)(dx+2*map_size*Math.cos(Math.PI*(angle+150)/180)),(int)(dx+2*map_size*Math.cos(Math.PI*(angle-150)/180)),};
		int py[]={(int)(dy+2*map_size*Math.sin(Math.PI*angle/180)),(int)(dy+2*map_size*Math.sin(Math.PI*(angle+150)/180)),(int)(dy+2*map_size*Math.sin(Math.PI*(angle-150)/180)),};
		offScreenG.setColor(Color.red);
		offScreenG.fillPolygon(px,py,3);
	}
	//-------------------------------------
	//tO
	public void setAhead(boolean flag){
		ahead=flag;
	}
	public void setBack(boolean flag){
		back=flag;
	}
	public void setRight(boolean flag){
		right=flag;
	}
	public void setLeft(boolean flag){
		left=flag;
	}
	//---------------------------------------
	private void setPos(){
		if(ahead){
			posx+=speed*Math.cos(Math.PI*angle/180);
			posy+=speed*Math.sin(Math.PI*angle/180);
		}
		if(back){
			posx-=speed*Math.cos(Math.PI*angle/180);
			posy-=speed*Math.sin(Math.PI*angle/180);
		}
		if(posx<0){
			posx+=x_max;
		}else if(posx>x_max){
			posx-=x_max;
		}
		if(posy<0){
			posy+=y_max;
		}else if(posy>y_max){
			posy-=y_max;
		}
		if(right){
			angle+=rotation;
		}
		if(left){
			angle-=rotation;
		}
		if(angle<0){
			angle+=360;
		}else if(angle>=360){
			angle-=360;
		}
	}
	private void setStar(){
		for(int i=0;i<star_num;i++){
			if(ahead){
				star_x[i]+=1+(int)((star_x[i]-400)/50);
				star_y[i]-=1+(int)((600-star_y[i])/50);
			}
			if(back){
				star_x[i]-=1+(int)((star_x[i]-400)/50);
				star_y[i]+=1+(int)((600-star_y[i])/50);
			}
			if(right){
				star_x[i]-=1+(int)(60*100/(Math.abs(star_x[i]-400)+100));
			}
			if(left){
				star_x[i]+=1+(int)(60*100/(Math.abs(star_x[i]-400)+100));
			}
			if(star_x[i]<0 || star_x[i]>800 || star_y[i]<0 || star_y[i]>400){
				star_x[i]=(int)(Math.random()*800);
				star_y[i]=(int)(Math.random()*400);
			}
		}
	}
	private void setBalls(){
		for(int i=0;i<ball_num;i++){
			if(ball_get[i]){
				continue;
			}
			double dx=balls[i].x-posx;
			if(dx>x_max/2){
				dx-=x_max;
			}else if(dx<-x_max/2){
				dx+=x_max;
			}
			double dy=balls[i].y-posy;
			if(dy>y_max/2){
				dy-=y_max;
			}else if(dy<-y_max/2){
				dy+=y_max;
			}
			double r=Math.sqrt( dx*dx+dy*dy );
			if(r>ball_depth_max){
				ball_r_ratio[i]=0;
			}else if(r<=ball_get_length){
				ball_get[i]=true;
			}else{
				double ex=dx*Math.cos(-Math.PI*angle/180)-dy*Math.sin(-Math.PI*angle/180);
				double ey=dx*Math.sin(-Math.PI*angle/180)+dy*Math.cos(-Math.PI*angle/180);
				if(ex<0){
					ball_r_ratio[i]=0;
				}else{
					ball_r_ratio[i]=(ball_depth_max-r)/ball_depth_max;
					ball_paint_y[i]=(int)(600-200*ex/ball_depth_max);
					ball_paint_x[i]=(int)(400+400*ey*ball_depth_max/(ex*ball_width_max));
				}
			}
		}
	}
	private void setHole(){
			double dx=hole.x-posx;
			if(dx>x_max/2){
				dx-=x_max;
			}else if(dx<-x_max/2){
				dx+=x_max;
			}
			double dy=hole.y-posy;
			if(dy>y_max/2){
				dy-=y_max;
			}else if(dy<-y_max/2){
				dy+=y_max;
			}
			double r=Math.sqrt( dx*dx+dy*dy );
			if(r>ball_depth_max){
				hole_r_ratio=0;
			}else if(r<=ball_get_length){
				formatPos();
			}else{
				double ex=dx*Math.cos(-Math.PI*angle/180)-dy*Math.sin(-Math.PI*angle/180);
				double ey=dx*Math.sin(-Math.PI*angle/180)+dy*Math.cos(-Math.PI*angle/180);
				if(ex<0){
					hole_r_ratio=0;
				}else{
					hole_r_ratio=(ball_depth_max-r)/ball_depth_max;
					hole_paint_y=(int)(600-200*ex/ball_depth_max);
					hole_paint_x=(int)(400+400*ey*ball_depth_max/(ex*ball_width_max));
				}
			}
	}
	//TimerNXŁAIɌĂяo
	public void actionPerformed(ActionEvent e) {
		//ʒu
		setPos();
		//
		setStar();
		//
		setBalls();
		//
		setHole();
		//ĕ`
		panel.repaint();
    }
}
